/*
SparkFun Bargraph Breakout example sketch
Mike Grusin, SparkFun Electronics

This sketch shows how to use the SFEbarGraph library to send data to SparkFun's Bargraph Breakout board

Hardware connections:

Connect the following pins on the bargraph board to your Arduino:

Name  Function  Uno pin   Mega pin

+5V Power supply  5V    5V
GND Ground    GND   GND
SIN SPI input 11 (MOSI) 51 (MOSI)
CLK Clock input   13 (SCK)  52 (SCK)
LAT Latch input   10 (SS)   53 (SS)

License:

This code is free to use, change, improve, even sell!  All we ask for is two things:
1. That you give SparkFun credit for the original code,
2. If you sell or give it away, you do so under the same license so others can do the same thing.
More at http://creativecommons.org/licenses/by-sa/3.0/

Have fun! 
-your friends at SparkFun
*/

// Step one: include both the SFEbarGraph and SPI libraries

#include <SparkFunBarGraph.h>
#include <SPI.h>

// Step two: create a bargraph object; we call it BG in this example but you can call it whatever you wish
// (use the same name in front of all the library functions)

SFEbarGraph BG;

// Some of the math we're doing in this example requires the number of bargraph boards
// you have connected together (normally this is one, but you can have a maximum of 8).

const int numbargraphs = 1;



// define LEDs, switches and pots for Sam's box
// 10,11, 13 taken by bar graph

// int LED_Star; // these could be simple circuits, not on a pin
// int LED_Saturn; // this one too
int LED_Ship_OUT = 3; // should be a PWM pin for pulsing effect
int LED_Ship_IN = 8; //the pin receives info from the switch

int brightness = 0;    // how bright the LED is
int fadeAmount = 5;    // how many points to fade the LED by

int LED_S_up = 6; // top of the S, controlled by left pot, yellow
int LED_S_dn = 9; // bottom of the S, controlled by right pot, blue

int S_POT_left = A5; //yellow
int S_POT_right = A1; // blue

int BarGraf_POT = A2;
// controls bar graph breakout board. CLK 13, SIN 11, LAT 10

int button_Ship = 0; 
// int button_Saturn; 
// int button_Star; 
//int brightness; //brightness of the Ship LED

//vslues for potentiometers
 int inputValue_L = 0;
 int outputValue_L = 0;

 int inputValue_R = 0;
 int outputValue_R = 0;

int powerMeter_IN = 0;
int powerMeter_OUT = 0;




void setup() // Runs once upon reboot
{
  // Let's initialize the bargraph library!
  // You can call BG.begin() several ways:

  // Without parameters, it defaults to one bargraph board and LATch pin set to 10 on Uno, or 53 on Mega.

  // You can also call it with the number of daisy-chained boards (1-8, default 1), using the default LATch pin.
  
  // Or you can call it with both the number of boards and the LATch pin you wish to use.
  // For two bargraphs and pin 9 for the latch pin, call BG.begin(2,9);
  
  BG.begin(numbargraphs);


//other stuff

pinMode(S_POT_left, INPUT);
pinMode(S_POT_right, INPUT);
pinMode(BarGraf_POT, INPUT);


pinMode(LED_Ship_OUT, OUTPUT);
pinMode(LED_Ship_IN, INPUT);
//digitalWrite(LED_Ship_IN, LOW);
//digitalWrite(LED_Ship_OUT, HIGH);
 Serial.begin(9600);      // turn on Serial Port for debugging

  
}


void loop() {

  // brightnesss control for the "S" leds. Left pot controls the uppers led in the S, YELLOW

 inputValue_L = analogRead(S_POT_left);  //Read the voltage on the left Potentiometer
 
 outputValue_L = map(inputValue_L, 0, 1023, 0, 255);  //Convert from 0-1023 proportional to the number of a number of from 0 to 255

 analogWrite(LED_S_up, outputValue_L);      //Write to the LED
// Serial.print("You are writing a value of ");  //for debugging print your values
//Serial.println(outputValue_L);

//Right side pot controls the lower led on the S, BLUE

 inputValue_R = analogRead(S_POT_right);  //Read the voltage on the right Potentiometer
 
 outputValue_R = map(inputValue_R, 0, 1023, 0, 255);  //Convert from 0-1023 proportional to the number of a number of from 0 to 255

 analogWrite(LED_S_dn, outputValue_R);      //Write to the LED
//Serial.print("You are writing a value of ");  //for debugging print your values
//Serial.println(outputValue_R);
Serial.println (analogRead(S_POT_left));


// ship engine switch
//read state of the button (switch)

button_Ship = digitalRead(LED_Ship_IN);
if (button_Ship == HIGH){
  


analogWrite(LED_Ship_OUT, brightness);
 // change the brightness for next time through the loop:
  brightness = brightness + fadeAmount;

  // reverse the direction of the fading at the ends of the fade:
  if (brightness <= 0 || brightness >= 255) {
    fadeAmount = -fadeAmount;
  }
  // wait for 30 milliseconds to see the dimming effect
  delay(10);
}

else {
    // turn LED off:
    digitalWrite(LED_Ship_OUT, LOW);
  }

/* digitalRead(LED_Ship_IN);
delay (50);

if (LED_Ship_IN,HIGH) { 
 digitalWrite(LED_Ship_OUT,HIGH); 
}
else {
digitalWrite(LED_Ship_OUT,LOW);
}

Serial.println(digitalRead(LED_Ship_IN));

*/
//Bar Graph control
powerMeter_IN = analogRead(BarGraf_POT);

powerMeter_OUT = map(powerMeter_IN, 0, 1023, 0, 30);
  unsigned char LED;
LED = powerMeter_OUT;

//BG.paint(
 // BG.Paint() lets you turn individual LEDs on and off. This is done on an internal "canvas".
  // Use clear() to set the canvas to all LEDs off. Use paint(LED, state) to turn an individual LED
  // on or off (for state, 1 or true or HIGH = on, 0 or false or LOW = off). LED numbering starts at 0.
  // When you're done "painting" the canvas and are ready to display it on the LEDs, call send();
  // The bargraph will continue displaying that data until you call send() again.
  


// for(LED=0;LED<(numbargraphs*30);LED++) // Increment through all the LEDs from 0 to as many as we have
  {

    
   BG.paint(LED,HIGH); // Turn LED on
   BG.send(); // Send the canvas to the bargraph
   delay(50);
  BG.clear(); 
if (LED>=30) {
bugs();
}
else if (LED<30) {

BG.clear();  
  }
}
}
 
 // }

    //how to turn off the LEDs as we turn the knob down???

    //maybe this
 //   BG.clear();
      
//    BG.paint(LED,LOW); // Turn LED off
 //   BG.send(); // Send the canvas to the bargraph
  //  delay(50);



/*  for(LED=0;LED<(numbargraphs*30);LED++) // Increment through all the LEDs from 0 to as many as we have
  {
    BG.paint(LED,LOW); // Turn LED off
    BG.send(); // Send the canvas to the bargraph
    delay(50);
  }
  delay(500);
*/

//bugs(); 







void bugs()  {



  // DANCING SINE BUGS!
  
  // Paint 8 moving bugs onto the bargraph, and watch them dance


  // Create 8 bugs
  float bug[8];
  int x;

  // Zero them all
  for(x=0; x<8; x++)
    bug[x] = 0.0;  
    
  // Do this for 30 seconds
 int endtime = millis() + 30000;
  while (millis() < endtime)
  {
    // Clear the canvas
    BG.clear();

    // Move each bug along a sine wave at different rates
    for(x=0; x<8; x++)
    {
      bug[x] += ((PI/8000.0) * (x+1));
      BG.paint((numbargraphs*15)+(sin(bug[x])*(numbargraphs * 15)),HIGH);
    }

    // Send the canvas to the display
    BG.send();
//attempting to interrupt the while loop - works! (mostly- every few times nothing happens. Wait a minute and it works again)

    if (analogRead(BarGraf_POT) <= 1020) {

break;
  
  }
  

  }
  BG.clear(); BG.send(); delay(500);


}
 /* if (millis() > endtime){
    loop();
  }
  //attempting to make it so if the pot is turned down the bugs go away
  
 /* else if (analogRead(BarGraf_POT)<1000) {
    loop();
  }
  }
  */
  





/*
// DANCING SINE BUGS!
  
  // Paint 8 moving bugs onto the bargraph, and watch them dance

  // Create 8 bugs
  float bug[8];
  int x;

  // Zero them all
  for(x=0; x<8; x++)
    bug[x] = 0.0;  
    
  // Do this for 30 seconds
//  int endtime = millis() + 30000;

  int READ = analogRead(BarGraf_POT);

 if (READ <= 1020)
  {
    // Clear the canvas
    BG.clear();

    // Move each bug along a sine wave at different rates
    for(x=0; x<8; x++)
    {
      bug[x] += ((PI/8000.0) * (x+1));
      BG.paint((numbargraphs*15)+(sin(bug[x])*(numbargraphs * 15)),HIGH);
    }

    // Send the canvas to the display
    BG.send();
  }
//  else if (READ <= 1010)
 // loop();

 BG.clear(); BG.send(); delay(500);
}
  
  */
 
